MusicPlayer_FubarPlugin = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceDB-2.0", "AceEvent-2.0")
MusicPlayer_FubarPlugin:RegisterDB("MusicPlayerFuDB")

MusicPlayer_FubarPlugin.name = "MusicPlayer"
MusicPlayer_FubarPlugin.version = MP_version
MusicPlayer_FubarPlugin.hasIcon = "Interface\\Addons\\MusicPlayer\\Images\\MusicPlayerIcon"
MusicPlayer_FubarPlugin.clickableTooltip = false
MusicPlayer_FubarPlugin.cannotDetachTooltip = true
MusicPlayer_FubarPlugin.hideWithoutStandby = true
MusicPlayer_FubarPlugin.defaultPosition = "RIGHT"
MusicPlayer_FubarPlugin.cannotAttachToMinimap = true
MusicPlayer_FubarPlugin.dontCreateMinimap = true

local L = AceLibrary("AceLocale-2.2"):new("FuBar_MusicPlayerFu")
local Tablet = AceLibrary("Tablet-2.0")

function MusicPlayer_FubarPlugin:OnTooltipUpdate()
	Tablet:SetHint("Playlist")
end

function MusicPlayerFu_DropDown_Initialize(level)
	level = level or 1;

	if (level == 1) then

		local info = {};
		info.text = MusicPlayer_LABEL_TITLE2;
		info.isTitle = 1;
		info.justifyH = "CENTER";
		info.notCheckable = 1;
		UIDropDownMenu_AddButton(info);

		local info = {};
		info.text = MusicPlayer_Next_Song;
		info.isTitle = nil;
		info.justifyH = "CENTER";
		info.notCheckable = 1;
		info.func = function(msg) MusicPlayer_PlayNextSong() end;
		UIDropDownMenu_AddButton(info);

		local info = {};
		info.text = MusicPlayer_Previous_Song;
		info.isTitle = nil;
		info.justifyH = "CENTER";
		info.notCheckable = 1;
		info.func = function(msg) MusicPlayer_PlayPrevSong() end;
		UIDropDownMenu_AddButton(info);

		local info = {};
		info.text = MusicPlayer_FadeSong;
		info.isTitle = nil;
		info.justifyH = "CENTER";
		info.notCheckable = 1;
		info.func = function(msg) MusicPlayerStop() end;
		UIDropDownMenu_AddButton(info);

		local info = {};
		info.text = MusicPlayer_LABEL_TITLE;
		info.isTitle = 1;
		info.justifyH = "CENTER";
		info.notCheckable = 1;
		UIDropDownMenu_AddButton(info);

		local num = MusicPlayer_GetSongs() / 10;
	
		for i = 1, ceil(num) do
	
			local info = {};
			if (num > 1) then
				info.text = "Playlist (Part "..i..")";
			else
				info.text = "Playlist";
			end
			info.hasArrow = true;
			info.justifyH = "CENTER";
			info.notCheckable = 1;
			info.value = {
				 ["Level1_Key"] = i;
			};
			UIDropDownMenu_AddButton(info, level);
		end
	end

	if (level == 2) then
		local Level1_Key = UIDROPDOWNMENU_MENU_VALUE["Level1_Key"];
		local SongNumMax = MusicPlayer_GetSongs();

		if (Level1_Key == 1) then
			if (SongNumMax > 10) then
				for i = 1, 10 do
					local info = UIDropDownMenu_CreateInfo();
					info.text = MusicPlayerSongs[i]["Title"];
					info.isTitle = nil;
					info.justifyH = "CENTER";
					info.notCheckable = 1;
					info.func = function(msg) MusicPlayer_PlaySong(i) end;
					UIDropDownMenu_AddButton(info, level);
				end
			else
				for i = 1, MusicPlayer_GetSongs() do
					local info = UIDropDownMenu_CreateInfo();
					info.text = MusicPlayerSongs[i]["Title"];
					info.isTitle = nil;
					info.justifyH = "CENTER";
					info.notCheckable = 1;
					info.func = function(msg) MusicPlayer_PlaySong(i) end;
					UIDropDownMenu_AddButton(info, level);
				end
			end
		else
			local start = Level1_Key * 10 - 9;

			if (SongNumMax > Level1_Key * 10) then
				local End = Level1_Key * 10;

				for i = start, End do
					local info = UIDropDownMenu_CreateInfo();
					info.text = MusicPlayerSongs[i]["Title"];
					info.isTitle = nil;
					info.justifyH = "CENTER";
					info.notCheckable = 1;
					info.func = function(msg) MusicPlayer_PlaySong(i) end;
					UIDropDownMenu_AddButton(info, level);
				end
			else
				for i = start, MusicPlayer_GetSongs() do
					local info = UIDropDownMenu_CreateInfo();
					info.text = MusicPlayerSongs[i]["Title"];
					info.isTitle = nil;
					info.justifyH = "CENTER";
					info.notCheckable = 1;
					info.func = function(msg) MusicPlayer_PlaySong(i) end;
					UIDropDownMenu_AddButton(info, level);
				end
			end
		end
	end
end


function MusicPlayer_FubarPlugin:OnClick()
	UIDropDownMenu_Initialize(MusicPlayerFu_DropDownFrame, MusicPlayerFu_DropDown_Initialize, "MENU");

	local frame = this:GetName();
	MusicPlayerFu_DropDownFrame:SetParent(frame);

	MusicPlayerFu_DropDownFrame:ClearAllPoints();
	MusicPlayerFu_DropDownFrame:SetPoint("TOP", frame, "CENTER", 0, -10);
	ToggleDropDownMenu(1, nil, MusicPlayerFu_DropDownFrame);
end